package com.yunzhi.marketing.config;

import com.yunzhi.marketing.delay.service.RedisDelayQueue;
import com.yunzhi.marketing.listener.VideoRedisListener;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.listener.ChannelTopic;
import org.springframework.data.redis.listener.RedisMessageListenerContainer;
import springfox.documentation.swagger2.mappers.ModelMapper;

import java.io.IOException;


/**
 * @author zhaodong
 * @date 2019/8/14
 */
@Configuration
public class RedisConfig {


    @Bean
    public RedisDelayQueue orderDelayQueue(RedisTemplate redisTemplate) throws IOException {
        return new RedisDelayQueue(redisTemplate);
    }

    @Bean
    public RedisMessageListenerContainer redisMessageListenerContainer(RedisConnectionFactory connectionFactory) {
        RedisMessageListenerContainer container = new RedisMessageListenerContainer();
        container.setConnectionFactory(connectionFactory);
        container.addMessageListener(new VideoRedisListener(""), new ChannelTopic(""));
        return container;
    }
}
