package com.yunzhi.marketing.delay.service;

import com.tdh.brokenmeeting.delay.DelayMessage;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.script.RedisScript;

import java.io.IOException;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.List;
import java.util.Set;

public class RedisDelayQueue {
    private final DateTimeFormatter dtf=DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
    private RedisScript<List> delayLuaScript;
    private RedisTemplate<String,Object> redisTemplate;


    public RedisDelayQueue(RedisTemplate redisTemplate) throws IOException {
        this.redisTemplate = redisTemplate;
//        String delayLuaScriptStr= IOUtils.toString(getClass().getClassLoader().getResourceAsStream("lua/delayLua.lua"), "utf-8");
//        delayLuaScript=new DefaultRedisScript<>(delayLuaScriptStr,List.class);
    }

    public <T> void add(DelayMessage<T> delayMessage, String redisDelayQueue){
        System.out.println("发送时间:"+ LocalDateTime.now().format(dtf)+",消息:" +delayMessage.getObject().toString());
        redisTemplate.opsForZSet().add(redisDelayQueue,delayMessage.getObject(),delayMessage.getScore());
    }

    public Set get(String redisDelayQueue){
        Set set = redisTemplate.opsForZSet().rangeByScore(redisDelayQueue, 0,new Double(new Date().getTime()));
        if(!set.isEmpty()){
            redisTemplate.opsForZSet().remove(redisDelayQueue,set.toArray());
        }
        return set;
    }

    public void remove(String key,String redisDelayQueue){
        redisTemplate.opsForZSet().remove(key,redisDelayQueue);
    }

}
